// This file is part of the SV-Benchmarks collection of verification tasks:
// https://gitlab.com/sosy-lab/benchmarking/sv-benchmarks
//
// SPDX-FileCopyrightText: 2020 Aman Goel
// SPDX-FileCopyrightText: 2022 The SV-Benchmarks Community
//
// SPDX-License-Identifier: GPL-3.0-or-later

// This C program is converted from Btor2 by Btor2C version sha1:a0fa249
//   with arguments: { architecture=64, lazy_modulo=false, use_memmove=false, unroll_inner_loops=false, shortest_type=true, diff_type=true, decimal_constant=true, zero_init=false, sra_extend_sign=true }
// Comments from the original Btor2 file:
// ; source: https://github.com/aman-goel/avr/tree/92362931700b66684418a991d018c9fbdbebc06f/tests
// ; BTOR description generated by Yosys 0.9+431 (git sha1 4a3b5437, clang 4.0.1-6 -fPIC -Os) for module main.
extern unsigned char __VERIFIER_nondet_uchar();
extern unsigned short __VERIFIER_nondet_ushort();
extern unsigned int __VERIFIER_nondet_uint();
extern unsigned long __VERIFIER_nondet_ulong();
extern unsigned __int128 __VERIFIER_nondet_uint128();
extern void abort(void);
extern void __assert_fail(const char *, const char *, unsigned int, const char *);
void reach_error() { __assert_fail("0", "seq.c", 0, "reach_error"); }
void __VERIFIER_assert(int cond) { if (!(cond)) { ERROR: { reach_error(); abort(); } } }
void assume_abort_if_not(int cond) { if (!cond) { abort(); } }
int main() {
  // Defining sorts ...
  typedef unsigned char SORT_1;  // BV with 1 bits
  const SORT_1 mask_SORT_1 = (SORT_1)-1 >> (sizeof(SORT_1) * 8 - 1);
  const SORT_1 msb_SORT_1 = (SORT_1)1 << (1 - 1);
  typedef unsigned __int128 SORT_4;  // BV with 101 bits
  const SORT_4 mask_SORT_4 = (SORT_4)-1 >> (sizeof(SORT_4) * 8 - 101);
  const SORT_4 msb_SORT_4 = (SORT_4)1 << (101 - 1);
  typedef unsigned int SORT_8;  // BV with 32 bits
  const SORT_8 mask_SORT_8 = (SORT_8)-1 >> (sizeof(SORT_8) * 8 - 32);
  const SORT_8 msb_SORT_8 = (SORT_8)1 << (32 - 1);
  // Initializing constants ...
  const SORT_4 var_5 = 1;
  const SORT_8 var_9 = 200;
  const SORT_1 var_14 = 1;
  const SORT_4 var_18 = 0;
  const SORT_8 var_23 = 100;
  // Collecting input declarations ...
  SORT_1 input_2;
  SORT_1 input_3;
  // Collecting state declarations ...
  SORT_4 state_6 = __VERIFIER_nondet_uint128() & mask_SORT_4;
  SORT_4 state_19 = __VERIFIER_nondet_uint128() & mask_SORT_4;
  // Initializing states ...
  SORT_4 init_7_arg_1 = var_5;
  state_6 = init_7_arg_1;
  SORT_4 init_20_arg_1 = var_18;
  state_19 = init_20_arg_1;
  for (;;) {
    // Getting external input values ...
    input_2 = __VERIFIER_nondet_uchar();
    input_2 = input_2 & mask_SORT_1;
    input_3 = __VERIFIER_nondet_uchar();
    input_3 = input_3 & mask_SORT_1;
    // Assuming invariants ...
    // Asserting properties ...
    SORT_8 var_10_arg_0 = var_9;
    SORT_4 var_10 = var_10_arg_0;
    SORT_4 var_11_arg_0 = state_6;
    SORT_4 var_11_arg_1 = var_10;
    SORT_1 var_11 = var_11_arg_0 < var_11_arg_1;
    SORT_1 var_15_arg_0 = var_11;
    SORT_1 var_15 = ~var_15_arg_0;
    var_15 = var_15 & mask_SORT_1;
    SORT_1 var_16_arg_0 = var_14;
    SORT_1 var_16_arg_1 = var_15;
    SORT_1 var_16 = var_16_arg_0 & var_16_arg_1;
    var_16 = var_16 & mask_SORT_1;
    SORT_1 bad_17_arg_0 = var_16;
    __VERIFIER_assert(!(bad_17_arg_0));
    // Computing next states ...
    SORT_8 var_24_arg_0 = var_23;
    SORT_4 var_24 = var_24_arg_0;
    SORT_4 var_25_arg_0 = state_6;
    SORT_4 var_25_arg_1 = var_24;
    SORT_1 var_25 = var_25_arg_0 < var_25_arg_1;
    SORT_4 var_22_arg_0 = state_19;
    SORT_4 var_22_arg_1 = state_6;
    SORT_4 var_22 = var_22_arg_0 + var_22_arg_1;
    var_22 = var_22 & mask_SORT_4;
    SORT_1 var_26_arg_0 = var_25;
    SORT_4 var_26_arg_1 = var_22;
    SORT_4 var_26_arg_2 = state_6;
    SORT_4 var_26 = var_26_arg_0 ? var_26_arg_1 : var_26_arg_2;
    SORT_4 next_27_arg_1 = var_26;
    SORT_4 next_28_arg_1 = state_6;
    // Assigning next states ...
    state_6 = next_27_arg_1;
    state_19 = next_28_arg_1;
  }
  return 0;
}
